cat("Machine address:\n")
print(system("hostname"))

softwaretype<-NA

#parameters of the process to invoke
false<-F
true<-T
softwaretype<-'Knime-Workflow'
softwareName<-'SimpleSample.knwf'
test<-"besttest"
cat('Input Parameter:test',test,'\n')
overallInput<-'test'
overallInputValues<-paste(test,sep='	')
overallInputTypes<-'String'



external_process_to_invoke<-'SimpleSample.knwf' #can be a python, fortran, linux-compiled, octave, java process
#prepare the command to invoke
command = paste(external_process_to_invoke,paste('"',test,'"',sep=''),sep=" ")
cat('Command:',command,'\n')



cat("Adding rights to the files\n")
logs<-system("chmod 777 *", intern = TRUE)
cat("computation started\n")
cat("software type:",softwaretype,"\n")

#global variables
gcube_username<-ifelse(exists("gcube_username"),gcube_username,"")
gcube_context<-ifelse(exists("gcube_context"),gcube_context,"")
gcube_token<-ifelse(exists("gcube_token"),gcube_token,"")
host<-system("hostname")

globalvariable = (c("gcube_username", "gcube_context", "gcube_token","hostname"))
globalvalue = (c(gcube_username, gcube_context, gcube_token,host))
processdf = data.frame(globalvariable, globalvalue)
cat("Global variables:\n")
print(processdf)
write.csv(file="globalvariables.csv",processdf,row.names = F)

#run the process
if (is.na(softwaretype)){
}else if (softwaretype=='Windows-compiled'){
	cat("Windows computation\n")
	command<-paste('mono ./',command,sep='')
}else if (softwaretype=='Linux-compiled'){
	cat("Linux computation\n")
	command<-paste('./',command,sep='')
}else if (softwaretype=='Pre-Installed'){
	cat("Pre-installed computation\n")
	cat("Cleaning dos lines\n")
	softwareNameTemp<-paste(softwareName,".1",sep="")
	cleanDosLines<-paste("sed -e 's/\x0D$//' ",softwareName," > ", softwareNameTemp,sep="")
	cat("Cleaning command step 1:",cleanDosLines,"\n")
	system(cleanDosLines, intern = TRUE)
	cleanDosLines<-paste("cp ",softwareNameTemp," ", softwareName,sep="")
	cat("Cleaning command step 2:",cleanDosLines,"\n")
	system(cleanDosLines, intern = TRUE)
	command<-paste('./',command,sep='')
}else if (softwaretype=='R-blackbox'){
	cat("R computation\n")
	command<-paste('Rscript --vanilla ',command,sep='')
}else if (softwaretype=='Python'){
	cat("Python computation\n")
	#command<-paste('python -m ',command,sep='')
	command<-paste('python ',command,sep='')
}else if (softwaretype=='Python3.6'){
	cat("Python3.6 computation\n")
	command<-paste('python3.6 -m ',command,sep='')	
}else if (softwaretype=='Java'){
	cat("Java computation\n")
	command<-paste('java -cp ./',command,sep='')
}else if (softwaretype=='Octave'){
	cat("Octave computation\n")
	command<-paste('octave ./',command,sep='')
}else if (softwaretype=='Knime-Workflow'){
  cat("Knime computation\n")
  workflow<-"workflow.knwf"
  if (file.exists(paste(softwareName,'.zip',sep='')))
    file.rename(paste(softwareName,'.zip',sep=''),softwareName)
  #EXAMPLE: knime -reset -consoleLog -nosplash -application org.knime.product.KNIME_BATCH_APPLICATION 
  #-workflowFile=SimpleSample.knwf -destFile=out.zip -workflow.variable=test,"besttest",String
  oI<-strsplit(overallInput,"\t")
  oIv<-strsplit(overallInputValues,"\t")
  oIt<-strsplit(overallInputTypes,"\t")

  knimevariables<-""
  for (i in 1:length(oI[[1]])){
		oinp<-oI[[1]][i]
		oinpv<-oIv[[1]][i]
		oinpt<-oIt[[1]][i]
		if (tolower(oinpt) == 'integer')
			oinpt<-"int"
		else if (tolower(oinpt) == 'double')
			oinpt<-"double"
		else {
			oinpv<-gsub(' ', '_', oinpv)
			oinpv<-gsub(',', ';', oinpv)
			oinpt<-"String"
		}
		
		knimevar = paste(oinp,",",'"',oinpv,'"',",",oinpt,sep="")
		
		knimevariables<-paste(knimevariables,' -workflow.variable=',knimevar,sep="")
		
	}
  command<-paste('/usr/local/bin/knime -reset -consoleLog -nosplash -application org.knime.product.KNIME_BATCH_APPLICATION -workflowFile=',softwareName,' -destFile=',workflow,knimevariables, sep='')
}
	
cat(command,"\n")
logs<-system(command, intern = TRUE)
cat("computation finished\n")
cat("Logs of the computation\n")
print(logs)
cat("\n")


#prepare the final output file
outputfolder <- getwd() #current working folder (a temporary folder is created at each run and set as working directory)
workflow<-"workflow.knwf"
cat('Output Parameter:workflow',workflow,'\n')
outfile<-"testWriting.csv"
cat('Output Parameter:outfile',outfile,'\n')



#check if the output exists before exiting
fexists = file.exists(paste(workflow,sep=''))
cat("file workflow exists?",fexists,"\n")
if (!fexists){
	cat(fexists,"Error, the output workflow(workflow.knwf) does not exist!\n")
	stoptheprocess
}

fexists = file.exists(paste(outfile,sep=''))
cat("file outfile exists?",fexists,"\n")
if (!fexists){
	cat(fexists,"Error, the output outfile(testWriting.csv) does not exist!\n")
	stoptheprocess
}


