package org.gcube.dataanalysis.executor.rscripts;

import java.io.File;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import org.gcube.dataanalysis.ecoengine.datatypes.PrimitiveType;
import org.gcube.dataanalysis.ecoengine.datatypes.StatisticalType;
import org.gcube.dataanalysis.ecoengine.datatypes.enumtypes.PrimitiveTypes;
import org.gcube.dataanalysis.executor.rscripts.generic.GenericRScript;
import org.gcube.dataanalysis.ecoengine.utils.DynamicEnum;
import java.lang.reflect.Field;

public class KnimeBlackBox extends GenericRScript {

	@Override
	public String getDescription() {
		return "Knime Black Box {Published by Giancarlo Panichi (giancarlo.panichi) on 2018/11/28 11:54 GMT}";
	}

	protected void initVariables(){
		mainScriptName="KnimeBlackBox/Main.R";
		packageURL="https://data.d4science.org/shub/890d83a7-912d-4020-b51d-e909677cb846";
		environmentalvariables = new ArrayList<String>();

		inputvariables.add("test");
		outputvariables.add("workflow");
		outputvariables.add("outfile");
	}

	@Override
	protected void setInputParameters() {
		inputs.add(new PrimitiveType(String.class.getName(), null,PrimitiveTypes.STRING, "test", "test", "besttest"));
	}

	@Override
	public StatisticalType getOutput() {
		output.put("workflow",new PrimitiveType(File.class.getName(), new File(outputValues.get("workflow")), PrimitiveTypes.FILE, "workflow", "workflow"));
		output.put("outfile",new PrimitiveType(File.class.getName(), new File(outputValues.get("outfile")), PrimitiveTypes.FILE, "outfile", "outfile"));
		PrimitiveType o = new PrimitiveType(LinkedHashMap.class.getName(), output, PrimitiveTypes.MAP, "Output", "");
		return o;
	}
}
